> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.awork.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server.

# Updates a specifc action of a project automation.

PUT https://api.awork.com/api/v1/projects/{projectId}/automations/{automationId}/actions/{actionId}
Content-Type: application/json

Updates an exsting action including its values for an automation. Actions of automations created from a workflow cannot be modified.
The user must be owner of the project or must have `project-master-data:write` permissions on the specified project.

Reference: https://developers.awork.com/apiv1/project-automations/put-project-automation-action

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `projectId` (string, required) — The id of the project of the automation.
- `automationId` (string, required) — The id of the automation.
- `actionId` (string, required) — The id of the action.

### Body (application/json)

This endpoint expects an ActionForm.

- `type` (string, required) — The type of the action.
- `values` (list of ActionValuePostForm, required) — The values of the action.
- `order` (double, optional, nullable) — The order of the action.

## Response

### 200

OK

- `id` (string, optional) — The id of the action.
- `createdBy` (string, optional) — The id of the user who created the action.
- `createdOn` (string, optional) — The date the action was created.
- `updatedBy` (string, optional) — The id of the user who updated the action.
- `updatedOn` (string, optional) — The date the action was updated.
- `type` (string, optional, nullable) — The type of the action.
- `order` (double, optional, nullable) — The order of the action.
- `values` (list of ActionValue, optional, nullable) — The values of the action.

## Errors

### 400 Bad Request Error

Bad Request

- `code` (string, required) — The error code.
- `description` (string, required) — The description of the error.
- `link` (string, required) — The link to the API documentation page.
- `details` (list of string, optional, nullable) — A list of details describing the error.
- `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property.
- `traceId` (string, optional, nullable) — The request trace id for tracking the request.

## Types

### ActionValuePostForm

- `name` (string, required) — The name of the action value.
- `value` (any, required) — The value of the action value.

### ActionValue

- `name` (string, optional, nullable) — The name of the action value.
- `value` (string, optional, nullable) — The value of the action value.

### ValidationErrorResponse

The validation error response.

- `property` (string, optional, nullable) — The name of the property that failed validation.
- `message` (string, optional, nullable) — The reason why this property failed validation.

## Examples

**Request**

```json
{
  "type": "tag-add-task",
  "values": [
    {
      "name": "user",
      "value": null
    }
  ]
}
```

**Response**

```json
{
  "id": "123e4567-e89b-12d3-a456-426614174000",
  "createdBy": "123e4567-e89b-12d3-a456-426614174000",
  "createdOn": "2024-01-15T09:30:00Z",
  "updatedBy": "123e4567-e89b-12d3-a456-426614174000",
  "updatedOn": "2024-01-15T09:30:00Z",
  "type": "tag-add-task",
  "order": 2,
  "values": [
    {
      "name": "tag",
      "value": "Design"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.awork.com/api/v1/projects/projectId/automations/automationId/actions/actionId"

payload = {
    "type": "tag-add-task",
    "values": [
        {
            "name": "user",
            "value": None
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.awork.com/api/v1/projects/projectId/automations/automationId/actions/actionId';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"type":"tag-add-task","values":[{"name":"user","value":null}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.awork.com/api/v1/projects/projectId/automations/automationId/actions/actionId"

	payload := strings.NewReader("{\n  \"type\": \"tag-add-task\",\n  \"values\": [\n    {\n      \"name\": \"user\",\n      \"value\": null\n    }\n  ]\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.awork.com/api/v1/projects/projectId/automations/automationId/actions/actionId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"type\": \"tag-add-task\",\n  \"values\": [\n    {\n      \"name\": \"user\",\n      \"value\": null\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.awork.com/api/v1/projects/projectId/automations/automationId/actions/actionId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"type\": \"tag-add-task\",\n  \"values\": [\n    {\n      \"name\": \"user\",\n      \"value\": null\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.awork.com/api/v1/projects/projectId/automations/automationId/actions/actionId', [
  'body' => '{
  "type": "tag-add-task",
  "values": [
    {
      "name": "user",
      "value": null
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.awork.com/api/v1/projects/projectId/automations/automationId/actions/actionId");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"type\": \"tag-add-task\",\n  \"values\": [\n    {\n      \"name\": \"user\",\n      \"value\": null\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "type": "tag-add-task",
  "values": [
    [
      "name": "user",
      "value": 
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/projects/projectId/automations/automationId/actions/actionId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```